#!/usr/bin/env python
#Author: Tyler Clemons 
#Email: tyler@tylerclemons.com
#Website Source: http://www.tylerclemons.com/itunes-scripting-with-python/
#August 2008
#Use and abuse give credit if you do :)
#This script  creates playists that only play specific albums in iTunes
#Places all playlist inside a folder called Album Folder by default
#Distributed under the GNU GENERAL PUBLIC LICENSE

from appscript import *

itunes = app('itunes')

#CHANGE IF YOU WANT A DIFFERENT FOLDER NAME
fname = "Album Folder"

#gather the current playlists
playlists = {}
album_folder = False

for playlist in itunes.playlists():
    playlists[playlist.name()] = playlist
    if playlist.name() == fname:
        album_folder = playlist

#grab the main library
lib = itunes.library_playlists['Library']
#albums is a dictionary of Album titles => playlist handle
albums = {}
#then take out the tracks
tracks = lib.tracks()

#make album folder if it wasn't found
if not album_folder:
    album_folder = itunes.make(new=k.folder_playlist, with_properties={k.name:fname})

for track in tracks:
    album = track.album()
    #check for empty values
    if album == "":
        album = "Unknown Album"
    #check for already created lists
    if not playlists.has_key(album):
        #if the list is not created, make it
        if not albums.has_key(album):
            albums[album] =  itunes.make(new=k.user_playlist, at=album_folder , with_properties={k.name:album})
        #move the track to the appropriate list
        itunes.duplicate(track,to=albums[album])
    
    #if a list exist, check if the file is inside
    else:
        #iterate over each song in the playlist
        #if no match, continue and add song
        #otherwise break loop and dont add song
        #This part can take a long time

        match = False
        for song in itunes.playlists[album].tracks():
            if song.name() != track.name():
                continue
            else:
                match = True
                break
        if match == False:
            itunes.duplicate(track,to=playlists[album])
            


